import sys
import re

# Словарь для перевода "гопнического" языка в Python
gop_dict = {
    # Основные конструкции
    "погнали_ебать_функция": "def", 
    "есличё_бля": "if", 
    "или_если_хуйня": "elif", 
    "или_пиздец": "else",
    "погнали_по_хуйне": "for", 
    "пока_пиздец_крутится": "while", 
    "попробуй_бери_нахуй": "try",
    "если_пиздец_пришёл": "except", 
    "в_итоге_хуйня": "finally", 
    "кидай_пиздец": "raise",
    "вали_отсюда_нахуй": "return", 
    "съеби_отсюда": "break", 
    "хуй_с_ним_дальше": "continue",
    "хуйня_классная": "class", 
    "тащи_сюда_бля": "import", 
    "откуда_нахуй": "from", 
    "зови_бля": "as",
    "с_этим_хуем": "with", 
    "пох_пока": "pass", 
    "везде_бери_хуй": "global", 
    "не_тут_бери_хуй": "nonlocal",
    "выдавай_по_одному_нахуй": "yield", 
    "короткая_хуйня": "lambda", 
    "асинк_бери_нахуй": "async",
    "жди_бля": "await", 
    "удали_нахуй": "del", 
    "проверь_бля": "assert", 
    "сравни_пиздец": "match",
    "если_так_хуйня": "case", 

    # Операторы
    "забиваем_бля": "=", 
    "пиздец_больше": ">", 
    "пиздец_меньше": "<",
    "больше_или_равно_хуй": ">=", 
    "меньше_или_равно_хуй": "<=", 
    "один_хер": "==", 
    "не_пох_бля": "!=",
    "плюс_нахуй": "+", 
    "минус_бля": "-", 
    "умножить_пиздец": "*", 
    "поделить_хуйню": "/", 
    "поделить_без_хуйни": "//", 
    "остаток_бери": "%", 
    "в_степень_пиздец": "**", 
    "и_по_битам_бля": "&",
    "или_по_битам_хуй": "|", 
    "исключить_хуйню": "^", 
    "переверни_бля": "~", 
    "сдвиг_влево_нахуй": "<<",
    "сдвиг_вправо_нахуй": ">>", 
    "добавь_бля": "+=", 
    "убери_хуй": "-=", 
    "умножь_пиздец": "*=",
    "дели_нахуй": "/=", 
    "дели_чётко_бля": "//=", 
    "остаток_забивай": "%=", 
    "степень_нахуй": "**=",
    "битами_и_хуй": "&=", 
    "битами_или_бля": "|=", 
    "битами_исключи": "^=", 
    "сдвиг_влево_бери": "<<=",
    "сдвиг_вправо_хуй": ">>=", 
    "и_бля": "and", 
    "или_хуй": "or", 
    "не_ебёт": "not", 
    "в_этой_хуйне": "in",
    "это_бля": "is", 
    "не_это_хуй": "is not", 

    # Декораторы и типизация
    "декоратор_бери": "@", 
    "тип_вали_нахуй": "->", 

    # Встроенные функции и базовые операции
    "покажи_бля": "print", 
    "давай_вводи_нахуй": "input", 
    "диапазон_пиздец": "range", 
    "длина_хуйни": "len", 
    "число_целое_бери": "int",
    "число_с_хуйнёй": "float", 
    "строка_бля": "str", 
    "список_хуйни": "list", 
    "словарь_пиздец": "dict",
    "куча_без_повторов": "set", 
    "чётко_бля": "True", 
    "хуйня_полная": "False", 
    "нихуя_нет": "None", 

    # Разделители
    " нах": ":", 
    " и_пиздец": ",", 

    # Асинхронность
    "asyncio_бери_run": "asyncio.run", 

    # Работа со списками
    "добавь_в_список_ебать": "append", 
    "добавь_всё_похер": "extend", 
    "вставь_пиздец": "insert", 
    "выкинь_хуйню": "remove", 
    "выдерни_нахуй": "pop", 
    "очисти_всё_бери": "clear", 
    "найди_хуйню_йопта": "index", 
    "посчитай_пиздец_ебаный": "count", 
    "сортируй_ебать": "sort", 
    "переверни_всё_пох": "reverse", 
    "скопируй_бери_пиздец": "copy", 

    # Работа со словарями
    "достань_ключи_ебать": "keys", 
    "достань_значения_пох": "values", 
    "достань_всё_ебаный": "items", 
    "достань_или_похер": "get", 
    "добавь_или_обнови_бери": "update", 
    "выдерни_из_словаря_хуйло": "popitem", 

    # Работа со строками
    "разбей_хуйню_похер": "split", 
    "соединяй_ебать_йопта": "join", 
    "замени_пиздец_наебал": "replace", 
    "найди_в_строке_ебаный": "find", 
    "проверь_начало_хуйло": "startswith", 
    "проверь_конец_пиздец": "endswith", 
    "всё_в_верх_ебать": "upper", 
    "всё_в_низ_пох": "lower", 
    "убери_пробелы_бери": "strip", 
    "форматируй_пиздец_йопта": "format", 

    # Математические функции
    "квадратный_корень_ебаный": "math.sqrt", 
    "синус_пиздец_ебать": "math.sin", 
    "косинус_хуйло": "math.cos", 
    "тангенс_бери_пох": "math.tan", 
    "логарифм_нахуй_йопта": "math.log", 
    "округли_хуйню_ебать": "round", 
    "абсолютно_пиздец": "abs", 
    "максимум_ебаный": "max", 
    "минимум_хуйло": "min", 
    "суммируй_всё_пох": "sum", 

    # Работа с файлами
    "открой_файл_ебаный": "open", 
    "прочитай_всё_похер": "read", 
    "прочитай_строки_пиздец": "readlines", 
    "запиши_хуйню_йопта": "write", 
    "закрой_файл_бери": "close", 

    # Работа со временем и датами
    "время_пиздец_ебать": "time.time", 
    "спи_бери_хуйло": "time.sleep", 
    "сейчас_ебаный": "datetime.datetime.now", 
    "форматируй_время_пох": "strftime", 

    # Случайности
    "случайное_хуйло_йопта": "random.random", 
    "случайное_целое_бери": "random.randint", 
    "перемешай_всё_ебать": "random.shuffle", 
    "выбери_хуйню_пох": "random.choice", 

    # Новые функции и выражения
    "хуй_пойми_что": "type", 
    "похер_на_ошибки_йопта": "sys.exit", 
    "ебать_какой_пиздец": "id", 
    "хуйня_какая_то": "dir", 
    "пиздец_всё_хуйня": "all", 
    "ебать_хоть_что_то": "any", 
    "ебать_с_ума_сойти": "sys.maxsize", 
    "пиздец_какой_ебанутый": "sorted", 
    "хуйня_в_ебаный_список": "enumerate", 
    "пиздец_фильтруй_ебать": "filter", 
    "хуйня_маппинг_пох": "map", 
    "ебать_сжать_пиздец": "zip", 
    "пиздец_какой_еблан": "chr", 
    "хуйня_в_код_ебать": "ord", 
    "ебать_в_другую_хуйню": "isinstance", 
    "пиздец_наебать_йопта": "hash", 
    "хуйня_с_похером": "next", 
    "ебать_похер_итератор": "iter", 
    "пиздец_ебаный_глобал": "globals", 
    "хуйня_локальная_ебать": "locals",
}

def translate_gop_to_python(gop_code):
    # Разделяем код на строки
    lines = gop_code.split('\n')
    translated_lines = []

    for line in lines:
        # Обрабатываем импорты с "откуда_нахуй ... зови_бля"
        if "откуда_нахуй" in line and "зови_бля" in line:
            line = re.sub(
                r'откуда_нахуй\s+(\S+)\s+зови_бля\s+([^,\n]+(?:,\s*[^,\n]+)*)',
                r'from \1 import \2',
                line
            )
            # Заменяем "_бери_" на точку только в строках с импортами
            line = line.replace("_бери_", ".")
        
        translated_lines.append(line)
    
    # Собираем код обратно
    gop_code = '\n'.join(translated_lines)
    
    # Применяем замены из словаря ко всему коду
    sorted_items = sorted(gop_dict.items(), key=lambda x: len(x[0]), reverse=True)
    for gop_word, py_word in sorted_items:
        if gop_word in [" нах", " и_пиздец"]:
            gop_code = re.sub(r'' + re.escape(gop_word) + r'', py_word, gop_code)
        else:
            gop_code = re.sub(r'\b' + re.escape(gop_word) + r'\b', py_word, gop_code)
    
    return gop_code

if __name__ == "__main__":
    if len(sys.argv) < 2:
        print("Бери файл, пацан, йопта, пиздец как так то: python yoptapy.py твой_файл.py")
        sys.exit(1)
    
    filepath = sys.argv[1]
    with open(filepath, "r", encoding="utf-8") as f:
        gop_code = f.read()
    
    if not re.search(r"тащи_сюда_бля\s+yoptapy", gop_code):
        print("Бери 'тащи_сюда_бля yoptapy' в начале, пацан, пиздец как так то, ебать!")
        sys.exit(1)
    
    # Убираем импорт из кода
    gop_code = re.sub(r"тащи_сюда_бля\s+yoptapy\s*\n?", "", gop_code)
    py_code = translate_gop_to_python(gop_code)
    exec(py_code)